'use strict';

var ManterDiarioObraController = angular.module('ManterDiarioObraController', []);

ManterDiarioObraController.controller('ManterDiarioObraCtrl', ['$scope', '$location', '$filter', 'DiarioObra', 'Material', 'Construcao', 'Relatorio', 'UploadApp', 'CacheApp',
  ($scope, $location, $filter, DiarioObra, Material, Construcao, Relatorio, UploadApp, CacheApp) => {

    $scope.setDiarioObra = (diarioObra) => {
        if (diarioObra.ManhaSelecionada)
            diarioObra.TempoManha = diarioObra.ManhaSelecionada.Id;
        if (diarioObra.TardeSelecionada)
            diarioObra.TempoTarde = diarioObra.TardeSelecionada.Id;
        if (diarioObra.NoiteSelecionada)
            diarioObra.TempoNoite = diarioObra.NoiteSelecionada.Id;
        DiarioObra.setDiarioObra(diarioObra,
            (data) => {
                var retorno = data.Instance;
                if (retorno.Codigo != 0) {
                    $scope.msgBoxAtencao("Atenção", retorno.Mensagem, null);
                }
            });
    }

    $scope.getTipoTempo = () => {
        DiarioObra.getTipoTempo(
            (data) => {
                $scope.listaTempo = data.Instance;
                for (var i in data.Instance) {
                    if ($scope.diarioObra.TempoManha == data.Instance[i].Id)
                        $scope.diarioObra.ManhaSelecionada = data.Instance[i];
                    if ($scope.diarioObra.TempoTarde == data.Instance[i].Id)
                        $scope.diarioObra.TardeSelecionada = data.Instance[i];
                    if ($scope.diarioObra.TempoNoite == data.Instance[i].Id)
                        $scope.diarioObra.NoiteSelecionada = data.Instance[i];
                }
            }
        );
    }

    $scope.getItens = (item) => {
        DiarioObra.getDiarioObraItem(item,
            (data) => {

                switch (item.Item) {
                    case 'C':
                        $scope.colaboradores = data.Instance;
                        $scope.getListaFuncionario();
                        break;
                    case 'E':
                        $scope.equipamentos = data.Instance;
                        break;
                    case 'S':
                        $scope.servicos = data.Instance;
                        break;
                    case 'O':
                        $scope.ocorrencias = data.Instance;
                        break;
                }

            });
    }

    $scope.setItem = (item) => {
        DiarioObra.setDiarioObraItem(item,
            (data) => {
                switch (item.Item) {
                    case 'C':
                        $scope.getColaboradores();
                        break;
                    case 'E':
                        $scope.getEquipamentos();
                        break;
                    case 'S':
                        $scope.getServicos();
                        break;
                    case 'O':
                        // $scope.getOcorrencias();
                        $scope.updateOcorrencias();
                        break;
                }

            });
    }

    $scope.setItens = (item) => {
        item.Itens = JSON.stringify(item.Itens);
        DiarioObra.setDiarioObraItens(item,
            (data) => {
                switch (item.Item) {
                    case 'C':
                        $scope.getColaboradores();
                        break;
                    case 'E':
                        $scope.getEquipamentos();
                        break;
                    case 'S':
                        $scope.getServicos();
                        break;
                    case 'O':
                        $scope.getOcorrencias();
                        break;
                }

            });
    }

    $scope.delItem = (item) => {
        DiarioObra.delDiarioObraItem(item,
            (data) => {
                switch (item.Item) {
                    case 'C':
                        $scope.getColaboradores();
                        break;
                    case 'E':
                        $scope.getEquipamentos();
                        break;
                    case 'S':
                        $scope.getServicos();
                        break;
                    case 'O':
                        $scope.getOcorrencias();
                        break;
                }

            });
    }

    /* CRUD COLABORADORES */
    $scope.getColaboradores = () => {
        $scope.getItens({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            Item: 'C'
        });
    }

    $scope.adicionarColaborador = () => {
        var idCount = $scope.colaboradores.length;
        $scope.colaboradores.unshift({
            Novo: true,
            IdConstrucao: $scope.construcao.Id,
            IdItem: '',
            IdCount: idCount,
            Editar: $scope.getHtmlEditarColaborador()
        });
    }

    $scope.cancelarColaborador = (item) => {
        if (item.IdItem == 0) {
            var idx = $scope.colaboradores.indexOf(item);
            $scope.colaboradores.splice(idx, 1);
        }
        else
            item.Novo = false;
    }

    $scope.setColaborador = (item) => {
        var params = {
                IdDiarioObra: $scope.diarioObra.IdDiarioObra,
                Itens: [],
                Item: 'C'
        
            }
        item.Funcionarios.forEach(f => {
            var colab = $scope.funcionarios.filter(c => f.id == c.Id);
            if (colab.length > 0)
                params.Itens.push({
                    IdItem: colab[0].Id
                });
        })

        $scope.setItens(params);
    }

    $scope.delColaborador = (item) => {
        $scope.delItem({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            IdItem: item.IdItem,
            Item: 'C'
        });
    }

    $scope.getHtmlEditarColaborador = () => {
        return '' +
            '<form class="form col-lg-12 col-md-12 col-sm-12 col-xs-12 center-block" name="formColaborador">' +
            '    <div class="form-group">' +
            '       <div class="row">' +
            '           <div class="col-lg-10 col-md-10 col-sm-10 col-xs-10">' +
            `<am-multiselect multiple="true" ms-selected="---------- {{item.Funcionarios.length}} colaboradores(s) selecionada(s) ----------" ` +
            `ng-model="item.Funcionarios" ms-header="---------- Selecione os Colaboradores ----------" ` +
            `findshow="true" block="true" ` +
            `placeholder="Digite o nome do colaborador" ` +
            `options="(funcionario.Nome + ' (' + funcionario.Funcao + ')') for funcionario in funcionarios" style="cursor: pointer;"></am-multiselect> ` +
            '               <div class="showMobile"> <br /> </div> ' +
            '           </div>' +
            '           <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '	            <itemsalvar ng-click="!formColaborador.$invalid && setColaborador(item)"></itemsalvar>' +
            '	            <itemcancelar ng-click="cancelarColaborador(item)"></itemcancelar>' +
            '           </div>' +
            '       </div>' +
            '    </div>' +
            '</form>';
    }


    $scope.getListaFuncionario = () => {
        DiarioObra.getListaFuncionario($scope.construcao.Id,
            (data) => {
                $scope.funcionarios = data.Instance.filter(i => !$scope.colaboradores.some(c => c.IdFuncionario == i.Id));
            });
    }
    /* CRUD COLABORADOR */

    /* CRUD EQUIPAMENTO */
    $scope.getEquipamentos = () => {
        $scope.getItens({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            Item: 'E'
        });
    }

    $scope.adicionarEquipamento = () => {
        var idCount = $scope.equipamentos.length;
        $scope.equipamentos.unshift({
            Novo: true,
            IdConstrucao: $scope.construcao.Id,
            IdItem: '',
            IdCount: idCount,
            Editar: $scope.getHtmlEditarEquipamento()
        });
    }

    $scope.cancelarEquipamento = (item) => {
        if (item.IdItem == 0) {
            var idx = $scope.equipamentos.indexOf(item);
            $scope.equipamentos.splice(idx, 1);
        }
        else
            item.Novo = false;
    }

    $scope.setEquipamento = (item) => {

        if(!$scope.UnidadeEquipamentoNovo.Unidade){
            if (!item.selecionadoEquipamento) {
                $scope.msgBoxErro('Equipamento','Um equipamento deve ser selecionado na lista, caso este não exista adicione no cadastro de insumos.', function() {});
                return;
            }
            $scope.setItem({
                IdDiarioObra: $scope.diarioObra.IdDiarioObra,
                IdItem: item.selecionadoEquipamento.Id,
                Item: 'E'
            });
            $scope.UnidadeEquipamentoNovo = {};

        }else {

            $scope.cadastrandoMaterialNovo(item, function(idItem){
                $scope.setItem({
                    IdDiarioObra: $scope.diarioObra.IdDiarioObra,
                    IdItem: idItem,
                    Item: 'E'
                });
                $scope.UnidadeEquipamentoNovo = {};
            })
        };
        $scope.showEquipamento = true;
    }

    $scope.delEquipamento = (item) => {
        $scope.delItem({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            IdItem: item.IdItem,
            Item: 'E'
        });
    }

    /* override getLista(texto)  */
    $scope.getListaEquipamento = function(texto) {
        $scope.texto = texto;
        $scope.UnidadeEquipamentoNovo = {};
        $scope.showEquipamento = true;

        var params = {
            idConstrucao: $scope.construcao.Id,
            nome: texto,
        }
        Material.getListaBasePropria(params,
            (data) => {
                $scope.listaEquipamento = data.Instance;
            }
        );
    }

    /* override clickAdd()  */
    $scope.novoEquipamento = () => {
        CacheApp.setParaCadastro();
        $location.path('/materiais');
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoEquipamento = function(selecionado, item) {
        item.selecionadoEquipamento = selecionado;

        if(selecionado.showOff == undefined){
            $scope.showEquipamento = false;
        }else {
            $scope.showEquipamento = true;
        }
    }

    $scope.getListaUnidades = () => {
        Material.getListaUnidades(
            (data) => {
                $scope.listaUnidade = data.Instance;
                for (let i = 0; i < $scope.listaUnidade.length; i++) {
                    const TextoUnidadeView = `${$scope.listaUnidade[i].Descricao} (${$scope.listaUnidade[i].Sigla})`
                    $scope.listaUnidade[i].TextoUnidadeView = TextoUnidadeView;
                }
            }
        );
    };

    //$scope.novoEquipamento = {};
    $scope.setNovoMaterial = (item) => {

        item.IdConstrucao = $scope.construcao.Id;
        item.Novo = true;
        item.IdCount = 0;
        item.Item = "";
        item.selecionadoEquipamento = {};

        var selecionado = {};
        selecionado.Nome = $scope.texto;
        selecionado.Tipo = 3;
        selecionado.TipoDescricao = "Equipamento";
        selecionado.Origem = 0;
        selecionado.IdUnidade = $scope.UnidadeEquipamentoNovo.Unidade.Id;
        selecionado.Unidade = $scope.UnidadeEquipamentoNovo.Unidade.Descricao;
        selecionado.UnidadeSigla = $scope.UnidadeEquipamentoNovo.Unidade.Sigla;
        selecionado.showOff = true;

        $scope.setSelecionadoEquipamento(selecionado, item);
    }

    $scope.setNovoEquipamento = function(material, callBackFunction){
        Material.setMaterial($scope.construcao.Id, material,
            (data) => {
                var retorno = data.Instance[0];
                callBackFunction(retorno.IdMaterial);
            });
    }

    $scope.cadastrandoMaterialNovo = function(item, callBackFunction){

        var material = {};
        material.Codigo = "0";
        material.Id = "0";
        material.IdUnidade = item.selecionadoEquipamento.IdUnidade;
        material.Nome = item.selecionadoEquipamento.Nome;
        material.Novo = false;
        material.Tipo = item.selecionadoEquipamento.Tipo;
        material.TipoDescricao = item.selecionadoEquipamento.TipoDescricao;
        material.Unidade = item.selecionadoEquipamento.Unidade;
        material.UnidadeSigla = item.selecionadoEquipamento.UnidadeSigla
        material.Valor = "0";

        var idItem = 0;
        $scope.setNovoEquipamento(material, function(retorno){
            callBackFunction(retorno);
        });

    }

    $scope.getHtmlEditarEquipamento = () => {

        return '' +
            '<form class="form col-lg-12 col-md-12 col-sm-12 col-xs-12 center-block" name="formEquipamento">' +
            '    <div class="form-group">' +
            '       <div class="row">' +
            '           <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">' +
            '                <dropdowncomplete' +
            '                    ddc-placeholder="\'Digite o Nome do Equipamento\'"' +
            '                    ddc-showcodigo="true"' +
            '                    ddc-showvalor="false"' +
            '                    ddc-hideadd="true"'+
            '                    ddc-construcao="construcao"' +
            '                    ddc-item="item"' +
            '                    ddc-lista="listaEquipamento"' +
            '                    set-selecionado="setSelecionadoEquipamento(selecionado,item)"' +
            '                    get-lista="getListaEquipamento(texto)"' +
            '                    click-add="novoEquipamento()">' +
            '                </dropdowncomplete>' +
            '           </div>' +
            '           <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12" ng-show="showEquipamento">'+
            '               <select class="form-control"  ng-model="UnidadeEquipamentoNovo.Unidade" ng-change="setNovoMaterial(item)"'+
            '                       ng-options="unidade.TextoUnidadeView for unidade in listaUnidade track by unidade.Id">'+
            '	                <option style="display: none" value="" selected disabled> Unidade de referência </option>' +
            '               </select>'+
            '           </div>'+
            '           <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '	            <itemsalvar ng-click="!formEquipamento.$invalid && setEquipamento(item)"></itemsalvar>' +
            '	            <itemcancelar ng-click="cancelarEquipamento(item)"></itemcancelar>' +
            '           </div>' +
            '       </div>' +
            '       <div class="row">'+

            '       </div>'+
            '    </div>' +
            '</form>';
    }
    /* CRUD EQUIPAMENTO */

    /* CRUD SERVIÇO */
    $scope.getServicos = () => {
        $scope.getItens({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            Item: 'S'
        });
    }

    $scope.setServico = (item) => {

        if(!$scope.UnidadeServicoNovo.Unidade){
            if (!item.selecionadoServico) {
                $scope.msgBoxErro('Serviços','Um serviço deve ser selecionado na lista, caso este não exista adicione no cadastro de composições.', function() {});
                return;
            }

            $scope.setItem({
                IdDiarioObra: $scope.diarioObra.IdDiarioObra,
                IdItem: item.selecionadoServico.Id,
                Item: 'S'
            });
            $scope.UnidadeServicoNovo = {};

        }else {
            item.selecionadoEquipamento = item.selecionadoServico;
            $scope.cadastrandoMaterialNovo(item, function(idItem){
                var composicaoNova = {
                    Id: "0",
                    IdConstrucao: $scope.construcao.Id,
                    Codigo: "0",
                    Descricao: $scope.textoServico,
                    Unidade: item.selecionadoServico.Unidade,
                    UnidadeDescricao: item.selecionadoServico.UnidadeDescricao,
                    IdUnidade: item.selecionadoServico.IdUnidade,
                    Ordem: "0",
                    Itens: []
                }

                composicaoNova.Itens.push({
                    Id: idItem,
                    Consumo: 1,
                    ValorUnitario: "0"
                });

                UploadApp.setComposicao(composicaoNova, $scope.construcao.Id,
                    (result) => {
                        $scope.setItem({
                            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
                            IdItem: result.Instance.IdMaterial,
                            Item: 'S'
                        });
                        $scope.UnidadeServicoNovo = {};
                    });
            });

        };
        $scope.showServico = true;
    }

    $scope.delServico = (item) => {
        $scope.delItem({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            IdItem: item.IdItem,
            Item: 'S'
        });
    }

    $scope.adicionarServico = () => {
        var idCount = $scope.servicos.length;
        $scope.servicos.unshift({
            Novo: true,
            IdConstrucao: $scope.construcao.Id,
            IdItem: '',
            IdCount: idCount,
            Editar: $scope.getHtmlEditarServico()
        });
    }

    $scope.cancelarServico = (item) => {
        if (item.IdItem == 0) {
            var idx = $scope.servicos.indexOf(item);
            $scope.servicos.splice(idx, 1);
        }
        else
            item.Novo = false;
    }

    /* override getLista(texto)  */
    $scope.getListaServico = function(texto) {
        $scope.textoServico = texto;
        $scope.UnidadeServicoNovo = {};
        $scope.showServico = true;
        $scope.listaServico = $filter('filter')($scope.composicoes, {Descricao: texto});
        if ($scope.listaServico.length == 0)
            $scope.listaServico = $filter('filter')($scope.composicoes, {Codigo: texto});
    }

    /* override clickAdd()  */
    $scope.novoServico = () => {
        CacheApp.setParaCadastro();
        $location.path('/composicoes');
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoServico = function(selecionado, item) {
        item.selecionadoServico = selecionado;

        if(selecionado.showOff == undefined){
            $scope.showServico = false;
        }else {
            $scope.showServico = true;
        }
    }

    $scope.setNovoServico = function(item) {

        var unidadeMedida = $scope.UnidadeServicoNovo.Unidade;

        item.IdConstrucao = $scope.construcao.Id;

        var selecionado = {
            Codigo: 0,
            Custo: 0,
            CustoBDI: 0,
            CustoEncargos: 0,
            CustoTotal: 0,
            Descricao: $scope.textoServico,
            Nome: $scope.textoServico,
            Id: null,
            Itens: [],
            Ordem: "",
            Tipo: 5,
            Unidade: unidadeMedida.Descricao,
            IdUnidade: unidadeMedida.Id,

        };

        selecionado.Itens[0] = {};
        selecionado.Itens[0].BDI = 0;
        selecionado.Itens[0].Codigo = 0;
        selecionado.Itens[0].Coeficiente = 0;
        selecionado.Itens[0].Custo = 0;
        selecionado.Itens[0].CustoBDI = 0;
        selecionado.Itens[0].CustoEncargos = 0;
        selecionado.Itens[0].CustoTotal = 0;
        selecionado.Itens[0].Descricao = $scope.textoServico;
        selecionado.Itens[0].Nome = $scope.textoServico;
        selecionado.Itens[0].EncargoSocial = 0;
        selecionado.Itens[0].Id = 0;
        selecionado.Itens[0].IdUnidade = unidadeMedida.Id;
        selecionado.Itens[0].Origem = "0";
        selecionado.Itens[0].Tipo = 5;
        selecionado.Itens[0].TipoDescricao = "Serviço";
        selecionado.Itens[0].Unidade = unidadeMedida.Descricao;
        selecionado.Itens[0].ValorUnitario =0;

        selecionado.Ordem = "";
        selecionado.Tipo = 5;
        selecionado.Unidade = unidadeMedida.Sigla;
        selecionado.UnidadeDescricao = unidadeMedida.Descricao;
        selecionado.IdUnidade = unidadeMedida.Id;
        selecionado.showOff = true;

        $scope.setSelecionadoServico(selecionado, item)

    };

    $scope.getHtmlEditarServico = () => {

        return '' +
            '<form class="form col-lg-12 col-md-12 col-sm-12 col-xs-12 center-block" name="formServico">' +
            '    <div class="form-group">' +
            '       <div class="row">' +
            '           <div class="col-lg-5 col-md-5 col-sm-5 col-xs-12">' +
            '                <dropdowncomplete' +
            '                    ddc-placeholder="\'Digite o Nome do Serviço\'"' +
            '                    ddc-showcodigo="true"' +
            '                    ddc-showvalor="false"' +
            '                    ddc-hideadd="true"'+
            '                    ddc-construcao="construcao"' +
            '                    ddc-item="item"' +
            '                    ddc-lista="listaServico"' +
            '                    set-selecionado="setSelecionadoServico(selecionado,item)"' +
            '                    get-lista="getListaServico(texto)"' +
            '                    click-add="novoServico()">' +
            '                </dropdowncomplete>' +
            '           </div>' +
            '           <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12" ng-show="showServico">'+
            '               <select class="form-control"  ng-model="UnidadeServicoNovo.Unidade" ng-change="setNovoServico(item)"'+
            '                       ng-options="unidade.TextoUnidadeView for unidade in listaUnidade track by unidade.Id">'+
            '	                <option style="display: none" value="" selected disabled> Unidade de referência </option>' +
            '               </select>'+
            '           </div>'+
            '           <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '	            <itemsalvar ng-click="!formServico.$invalid && setServico(item)"></itemsalvar>' +
            '	            <itemcancelar ng-click="cancelarServico(item)"></itemcancelar>' +
            '           </div>' +
            '       </div>' +
            '    </div>' +
            '</form>';
    }
    /* CURD SERVIÇOS */

    /* CURD OCORRENCIAS */
    $scope.getOcorrencias = () => {
        $scope.getItens({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            Item: 'O'
        });
        $scope.saveImages = false;
    }

    $scope.updateOcorrencias = () => {
        var item = {
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            Item: 'O'
        }
        DiarioObra.getDiarioObraItem(item,
            (data) => {
                $scope.ocorrencias = $scope.ocorrencias.filter(i => i.Novo);

                data.Instance.forEach(i => {
                    $scope.ocorrencias.push(i);
                });
            });
    }

    $scope.setDOOcorrencia = (item) => {
        $scope.setItem({
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            IdItem: item.IdOcorrencia,
            Item: 'O'
        });
    }

    $scope.excluirOcorrencia = (ocorrencia) => {
        $scope.msgBoxPergunta('Ocorrência da ' + $scope.construcao.TipoDescricao, 'Confirma exclusão da ocorrência?'
            , () => {
                Construcao.delOcorrencia(ocorrencia.IdOcorrencia,
                    (data) => {
                        $scope.delItem({
                            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
                            IdItem: ocorrencia.IdOcorrencia,
                            Item: 'O'
                        });
                    });
            }
            , () => {
        });
    }

    $scope.adicionarOcorrencia = (img, files) => {
        var idCount = $scope.ocorrencias.length;
        $scope.ocorrencias.unshift({
            Novo: true,
            IdOcorrencia: 0,
            IdConstrucao: $scope.construcao.Id,
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            Descricao: '',
            Data: new Date($filter("date")($scope.diarioObra.Dia, 'yyyy-MM-ddT00:00:00Z')),
            IdCount: idCount,
            File: img,
            file: files
        });

        $scope.exibirDropZone = false;
    }

    $scope.adicionarImagemOcorrencia = (files) => {
        var idCount = $scope.ocorrencias.length;

        var ocorrencia = {
            Novo: true,
            IdOcorrencia: 0,
            IdConstrucao: $scope.construcao.Id,
            IdDiarioObra: $scope.diarioObra.IdDiarioObra,
            Descricao: '',
            Data: new Date($filter("date")($scope.diarioObra.Dia, 'yyyy-MM-ddT00:00:00Z')),
            IdCount: idCount,
            file: files
        }

        var reader = new FileReader();
        reader.onload = function(event) {
            ocorrencia.File =  event.target.result;
            $scope.exibirDropZone = false;
            $scope.$apply();
        }
        reader.readAsDataURL(files);

        $scope.ocorrencias.unshift(ocorrencia);
    }

    $scope.cancelaOcorrencia = (ocorrencia) => {
        var idx = $scope.ocorrencias.indexOf(ocorrencia)
        $scope.ocorrencias.splice(idx, 1);

        if (!$scope.ocorrencias.some(o => o.Novo))
            $scope.saveImages = false;
    }

    $scope.setOcorrencia = (ocorrencia) => {
        ocorrencia.Data = $filter("date")(ocorrencia.Data, 'yyyy-MM-dd 00:00:00')
        if (ocorrencia.file) {
            ocorrencia.progress = 0;
            UploadApp.setOcorrencia(ocorrencia,
                (progress) => {
                    ocorrencia.progress = progress;
                },
                (result) => {
                    ocorrencia.progress = null;
                    ocorrencia.IdOcorrencia = result.Instance.IdOcorrencia;
                    $scope.setDOOcorrencia(ocorrencia);
                    $scope.cancelaOcorrencia(ocorrencia);
                },
                (error) => { });
        }
        else {
            Construcao.setOcorrencia(ocorrencia.IdOcorrencia, $scope.construcao.Id, ocorrencia.Descricao, ocorrencia.Data,
                (data) => {
                    ocorrencia.IdOcorrencia = data.Instance.IdOcorrencia;
                    $scope.setDOOcorrencia(ocorrencia);
                    $scope.cancelaOcorrencia(ocorrencia);
                });
        }
    }
    // $scope.saveImages
    $scope.setListaOcorrenciaImagem = () => {
        function salvaImg(ocorrencia, callBackFunction) {
            ocorrencia.Data = $filter("date")(ocorrencia.Data, 'yyyy-MM-dd 00:00:00')
            if (ocorrencia.File) {
                ocorrencia.progress = 0;
                UploadApp.setOcorrencia(ocorrencia,
                    (progress) => {
                        ocorrencia.progress = progress;
                    },
                    (result) => {
                        ocorrencia.progress = null;
                        ocorrencia.IdOcorrencia = result.Instance.IdOcorrencia;
                        var item = {
                            IdDiarioObra: ocorrencia.IdDiarioObra,
                            IdItem: ocorrencia.IdOcorrencia,
                            Item: 'O'
                        }
                        DiarioObra.setDiarioObraItem(item,
                            (data) => {
                                callBackFunction();
                            }
                        );
                        $scope.cancelaOcorrencia(ocorrencia);
                    },
                    (error) => { });
                }
        }

        function salvaImgRecursivo(idx,imgs) {
            if (imgs.length == idx)
                $scope.getOcorrencias();
            else {
                salvaImg(imgs[idx], () => {
                    salvaImgRecursivo(idx+1,imgs);
                });
            }
        }

        salvaImgRecursivo(0,$scope.ocorrencias.filter(i => i.Novo));
    }

    $scope.blocoDeImagens = function() {
        $scope.exibirDropZone = true;

        document.querySelectorAll(".drop-zone__input").forEach((inputElement) => {
            const dropZoneElement = inputElement.closest(".drop-zone");

            dropZoneElement.addEventListener("click", (e) => {
                inputElement.click();
            });

            inputElement.addEventListener("change", (e) => {
                if (inputElement.files.length) {
                    const totImagens = inputElement.files.length;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.ocorrencias.some(c => c.file == files[i]))
                            continue;
                        $scope.adicionarImagemOcorrencia(files[i]);
                    }
                    $scope.saveImages = true;
                    $scope.$apply();
                }
            });

            dropZoneElement.addEventListener("dragover", (e) => {
                e.preventDefault();
                dropZoneElement.classList.add("drop-zone--over");
            });

            ["dragleave", "dragend"].forEach((type) => {
                dropZoneElement.addEventListener(type, (e) => {
                    dropZoneElement.classList.remove("drop-zone--over");
                });
            });

            dropZoneElement.addEventListener("drop", (e) => {
                e.preventDefault();

                if (e.dataTransfer.files.length) {
                    var files = e.dataTransfer.files;
                    const totImagens = files.length;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.ocorrencias.some(c => c.file == files[i]))
                            continue;
                        
                        $scope.adicionarImagemOcorrencia(files[i]);
                    }
                    $scope.saveImages = true;
                    $scope.$apply();
                }

                dropZoneElement.classList.remove("drop-zone--over");
            });
        }); 
    };

    $scope.showImage = (src, alt) => {
        var css = {
            'maxWidth': $(window).width() - 100,
            'maxHeight': $(window).height() - 100
        };

        var $lightbox = $('#lightbox');
        $lightbox.find('.close').addClass('hidden');
        $lightbox.find('img').attr('src', src);
        $lightbox.find('img').attr('alt', alt);
        $lightbox.find('img').css(css);

        $lightbox.on('shown.bs.modal', (e) => {
            var $img = $lightbox.find('img');

            $lightbox.find('.modal-dialog').css({ 'width': $img.width() });
            $lightbox.find('.close').removeClass('hidden');
        });

        $('#lightbox').modal('show');
    }

    $scope.pdfRelatorioDiarioObra = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy')
        };

        if ($scope.assinatura == true) {
            cabecalho.Responsavel = $scope.construcao.Contato
        };
        if ($scope.descricaoObra == true) {
            cabecalho.DescricaoObra = $scope.construcao.Descricao
        };

        Relatorio.pdfRelatorioDiarioObra($scope.diarioObra.IdDiarioObra, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.loadPageRDO = () => {
        $scope.construcao = $scope.obra;
        $scope.diarioObra = $scope.diario;
    
        $scope.assinatura = true;
        $scope.descricaoObra = true;
    
        $scope.showEquipamento = true;
        $scope.showServico = true;
        $scope.texto = '';
        $scope.textoServico = '';
        $scope.UnidadeEquipamentoNovo = {};
        $scope.UnidadeServicoNovo = {};

        $scope.base = {Origem: 0, UF:'', Periodo:''};

        $scope.getTipoTempo();
        $scope.getColaboradores();
        $scope.getEquipamentos();
        $scope.getListaUnidades();
        $scope.getServicos();
        Construcao.getComposicoes($scope.construcao.Id,
            (data) => {
                $scope.composicoes = data.Instance;
            });
        $scope.getOcorrencias();
    
    }
    
    $scope.msgBoxPergunta = (title, msg, usedFunctionSim, usedFunctionNao) => {
        swal({
            title: title,
            text: msg,
            type: 'question',
            showCancelButton: true,
            confirmButtonColor: '#263143',
            cancelButtonColor: '#F6A000',
            confirmButtonText: 'Sim',
            cancelButtonText: "Não"
            }).then((result) => {
            if (result.value)
                usedFunctionSim();
            else
                usedFunctionNao();
            });
    }

    $scope.msgBoxAtencao = (title, msg, usedFunctionOk) => {
        swal(
            title,
            msg,
            'warning'
            ).then((result) => {
            usedFunctionOk();
            });
    }

    $scope.msgBoxErro = (title, msg, usedFunctionOk) => {
        swal(
            title,
            msg,
            'error'
            ).then((result) => {
            usedFunctionOk();
            });
    }


    $scope.loadPageRDO();

}]);
